<!-- 技术指标 -->
<script lang="ts" setup name="DeviceTechnologyTable">
import { ElMessage, ElMessageBox } from 'element-plus'
import { useCheckList } from '@/utils/useCheckList'
const $props = defineProps({
  data: {
    type: Array,
    default: () => ([]),
  },
})
const $route = useRoute()
// 表头显示标题
const columns = ref([
  {
    text: '测量范围',
    value: 'measureRange',
    required: false,
    isSelect: false, // 是否下拉框
  },
  {
    text: '不确定度或允许误差极限或准确度等级',
    value: 'uncertainty',
    required: false,
    isSelect: false, // 是否下拉框
  },
  // {
  //   text: '依据的技术文件',
  //   value: 'basedDocuments',
  //   required: true,
  //   isSelect: false, // 是否下拉框
  // },
])
const list = ref<any[]>([])
// 检查数据列表
function checkCertificateList() {
  return useCheckList(list.value, columns.value, '技术指标')
}
// 将列表置为不可编辑状态
function setAllRowReadable() {
  for (const item of list.value) {
    item.editable = false
  }
}
// 双击行显示输入框
const dblclickRow = (row: any) => {
  if ($route.path.includes('detail')) {
    return
  }
  setAllRowReadable()
  row.editable = true
}
const SelectionList = ref()
// 表格选中
const handleSelectionChange = (e: any[]) => {
  SelectionList.value = e
}
// 添加行
const addRow = () => {
  if (checkCertificateList()) {
    setAllRowReadable()
    list.value.push({
      measureRange: '',
      uncertainty: '',
      basedDocuments: '',
      editable: true,
    })
  }
}
// 删除行
const removeRow = () => {
  list.value = list.value.filter((item) => {
    return !SelectionList.value.includes(item)
  })
}
watch(() => $props.data, (newVal) => {
  if (newVal) {
    list.value = newVal
  }
})
const initDialog = () => {
  list.value = $props.data
}
initDialog()
defineExpose({
  list,
  checkCertificateList,
})
</script>

<template>
  <detail-block-switch title="技术指标">
    <!-- <template v-if="!$route.path.includes('detail')" #btns>
      <el-button type="primary" @click="addRow">
        增加行
      </el-button>
      <el-button type="info" @click="removeRow">
        删除行
      </el-button>
    </template> -->
    <el-table
      ref="multipleTableRef" :data="list" style="width: 100%;" border @selection-change="handleSelectionChange"
      @row-dblclick="dblclickRow"
    >
      <!-- <el-table-column v-if="!$route.path.includes('detail')" type="selection" width="38" /> -->
      <el-table-column align="center" label="序号" width="80" type="index" />
      <el-table-column
        v-for="item in columns" :key="item.value" :prop="item.value" :label="item.text"
        align="center"
      >
        <template #header>
          <span v-show="item.required && !$route.path.includes('detail')" style="color: red;">*</span><span>{{ item.text }}</span>
        </template>
        <template #default="scope">
          <span v-if="!scope.row.editable">{{ scope.row[item.value] }}</span>
          <el-input
            v-if="scope.row.editable && !item.isSelect" v-model="scope.row[item.value]" :autofocus="true"
            :placeholder="`${item.text}`" class="input"
          />
          <!-- <el-date-picker v-if="scope.row.editable && item.isDate" v-model="scope.row[item.value]" type="date"
              format="YYYY-MM-DD" value-format="YYYY-MM-DD HH:mm:ss" :placeholder="`${item.text}`" /> -->
          <!-- <el-select
            v-if="scope.row.editable && item.isSelect" v-model="scope.row[item.value]"
            :placeholder="`${item.text}`"
          >
            <el-option v-for="item in platformListBak" :key="item.id" :label="item.name" :value="item.name" />
          </el-select> -->
        </template>
      </el-table-column>
    </el-table>
  </detail-block-switch>
</template>

<style lang="scss" scoped>
.el-dialog {
  width: 700px;
}

.el-select {
  width: 100%;
}
</style>
